/**
 * Counter
 *
 */
const counterElem = document.getElementById('counter');

let nbCounter = 0;

function increment() {
    nbCounter = nbCounter + 1;
    counterElem.innerText = nbCounter.toString();
}

function decrement() {
    nbCounter--;
    counterElem.innerText = nbCounter;
}

/**
 * Random Background
 */
const randomBackgroundElem = document.getElementById('randBg');

function getRandomColor() {
    const letters = '0123456789ABCDEF';
    let color = '#';
    for (let i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
}

function randomBackground() {
    randomBackgroundElem.style.backgroundColor = getRandomColor();
}


/**
 * Modal
 */
const modalElem = document.getElementById('modal');
const modalTextDisplayedElem = document.getElementById('modalTextDisplayed');
const modalTextElem = document.getElementById('modalText');

function modalOpen() {
    const modalText = modalTextElem.value;
    modalElem.classList.remove('modal_closed');
    modalTextDisplayedElem.innerText = modalText;
    modalElem.classList.add('modal');
}

function closeModal() {
    modalElem.classList.remove('modal');
    modalElem.classList.add('modal_closed');
}

/**
 * Verification de mot de passe
 */

const defaultVerifText = '<span style="color: black">Le mot de passe doit être compris avec au moins 5 caractères et être\n' +
    'identiques</span>';
const pwVerifText = document.getElementById('pwVerifText');
const pw1Input = document.getElementById('pw1Input');
const pw2Input = document.getElementById('pw2Input');


const verifyPassword1 = () => {
    if (pw1Input.value.length >= 5) {
        pw2Input.disabled = false;
    } else {
        pw2Input.value = '';
        pw2Input.disabled = true;
    }
};
const submitPassword = () => {
    if (!pw2Input.value || !pw1Input.value) {
        pwVerifText.innerHTML = '<span style="color: red">Il faut insérer son Mot-de-Passe et/ou le confirmer</span>';
    } else if (pw1Input.value === pw2Input.value) {
        pwVerifText.innerHTML = '<span style="color: green">C\'est bon, les mot-de-passe sont identiques !</span>';
    } else {
        pwVerifText.innerHTML = '<span style="color: red">Les deux mot-de passe doivent être identiques</span>';
    }
};


/**
 * TODOS
 {id: number, content: string, completed: boolean}
 */
let todos = [];
const todoListDiv = document.getElementById('todos');
const completedTodoListDiv = document.getElementById('completed-todos');
const todoInput = document.getElementById('todoInput');


const addTodo = () => {
    const newTodo = {
        id: todos.length + 1,
        content: todoInput.value,
        completed: false
    };
    //adds to the TodoArray
    todos.push(newTodo);
    //recreates the list of todos
    renderTodos();
    //resets value
    todoInput.value = '';
};


const deleteTodo = (id) => {
    //removes todo with id in the list.
    todos = todos.filter((todo) => todo.id !== id);
    //recreates the list of todos
    renderTodos();
    renderCompletedTodos();
};

const toggleCheckTodo = (id) => {
    //checks or unchecks todo
    todos.map(todo => {
        if (todo.id === id) {
            todo.completed = !todo.completed;
        }
        return todo;
    });

    renderCompletedTodos();
    renderTodos();

};

const renderCompletedTodos = () => {
    let newVue = '<ul class="todo-list completed">';
    todos.map(todo => {
        if (todo.completed) {
            newVue += '<li><label>' + todo.content + '</label><button class="delete-todo" onclick="deleteTodo(' + todo.id + ')">Delete</button><button class="complete-todo"  onclick="toggleCheckTodo(' + todo.id + ')">unCheck</button></li>'
        }
    });
    newVue += '</ul>';
    completedTodoListDiv.innerHTML = newVue;
};


const renderTodos = () => {
    let newVue = '<ul class="todo-list">';
    todos.map(todo => {
        if (!todo.completed) {
            newVue += '<li><label>' + todo.content + '</label><button class="delete-todo" onclick="deleteTodo(' + todo.id + ')">Delete</button><button class="complete-todo" onclick="toggleCheckTodo(' + todo.id + ')">check</button></li>'
        }
    });
    newVue += '</ul>';

    todoListDiv.innerHTML = newVue;
};


